<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.3 $
 * $Author: tora60 $
 * $Date: 2014-03-10 23:05:15 $
 */

$hook = function($module_name, $dummy, &$items)
{
    /* $dummy wird hier nicht bergeben, ist also immer leer */
    /* $items ergnzt die bestehende Liste */

    global $prefix, $user_prefix;

    $result = sql_num_rows(sql_query("select * from {$prefix}_mxboard_forums"));
    if ($result) {
        $items[] = array(/* Atttribute */
            'module' => $module_name,
            'url' => "modules.php?name=$module_name",
            'icon' => "modules/$module_name/images/agt_forum.png",
            'caption' => _BOARD . " - " . _STAT_FORACT,
            'value' => $result,
            );
    }
    $result = sql_num_rows(sql_query("select * from {$prefix}_mxboard_threads"));
    $result += sql_num_rows(sql_query("select * from {$prefix}_mxboard_posts"));
    if ($result) {
        $items[] = array(/* Atttribute */
            'module' => $module_name,
            'url' => "modules.php?name=$module_name",
            'icon' => "modules/$module_name/images/agt_forum.png",
            'caption' => _BOARD . " - " . _TEXTPOSTS,
            'value' => $result,
            );
    }
}

?>